-- Zaehlen von Operationen
module Eval3 where

import Term

-- 'CountOps a' ist eine Funktion, die einen Anfangswert des Zaehlers
-- uebergeben bekommt, und das Ergebnis der Berechnung sowie den Endwert
-- des Zaehlers zurueckgibt.
type CountOps a = Int -> (a, Int)

-- | 'eval' berechnet den Wert eines Ausdrucks.
eval :: Term -> CountOps Integer
eval (Const a)       = \cnt -> (a, cnt)
eval (Binary op a b) = \cnt ->
    error "nicht implementiert"

-- | 'evalOp' berechnet das Ergebnis einer binaeren Operation,
-- angewandt auf zwei Operanden.
evalOp :: Op -> Integer -> Integer -> CountOps Integer
evalOp Add a b = \cnt -> error "nicht implementiert"
-- ...
