module SignatureMorph where

import Signature


type Cons s a = s a -> a
type Decons s a = a -> s a


morphCons :: (s a -> t a) -> Cons t a -> Cons s a
morphCons = flip (.)

morphDecons :: (s a -> t a) -> Decons s a -> Decons t a
morphDecons = (.)
