-- einfacher Termevaluator
module Eval1 where

-- Fuer die Datentypen 'Term' und 'Op'
import Term

-- | 'eval' berechnet den Wert eines Ausdrucks.
eval :: Term -> Integer
eval (Const a) = a
eval (Binary op a b) = evalOp op (eval a) (eval b)

-- | 'evalOp' berechnet das Ergebnis einer binaeren Operation,
-- angewandt auf zwei Operanden.
evalOp :: Op -> Integer -> Integer -> Integer
evalOp Add a b = a + b
evalOp Sub a b = a - b
evalOp Mul a b = a * b
evalOp Div a b = a `div` b
