module Main (main) where

import Eval6
import Parser
import TermParser

main :: IO ()
main = do
    putStrLn "Enter terms, or an empty line to quit."
    getLine >>= main'

main' :: String -> IO ()
main' "" = return ()
main' ln = do
    case runParser' parseTerm ln of
        Unique t      -> print (eval' t)
        Ambiguous _ _ -> putStrLn "Ambiguous parse."
        ParseError    -> putStrLn "Parse error."
    getLine >>= main'