import Program
import VM
import InterpretVM
import Heap

import Control.Monad.State
import Data.Either
import Data.FiniteMap

nat = Coproduct (listToFM [("zero", Nothing), ("pred", Just nat)])
zero = UCotuple "zero" Nothing

one = Function "one" (Exponent [] [nat] []) (Just body) Nothing
    where body = Block [] [Cotuple "pred" nat, Dup, Param 0, Swap, Set, Body "pred", Cotuple "zero" nat, Set]

pone = Program
         (listToFM [("nat", nat)])
	 (listToFM [])
	 (listToFM [("one", one)])

testone = evalState (interpret pone (FunInterp "one" 0 [])) emptyHeap