module Value where

import Heap (Cell, Field)

newtype Slot = Slot Int deriving (Eq, Ord, Show, Enum)

data Value = Plain { fromPlain :: Cell }
	   | HeapRef { fromHeapRef :: Field }
	   | StackRef { fromStackRef :: Slot }
	   deriving (Eq, Ord, Show)
